// #name = DoubleWeapon
// #version = 1.2
// #date = 5th April 2001
// #author = Crunchy
// #email = crunchy@barrysworld.com
// #web = http://guides.barrysworld.com/tribes/scripts/
// #description = Select between two weapons using one key, lets you fit 10 weapons on 5 keys.
// #status = final

//
// --- Main Code ---
//

// START package DoubleWeapon
package DoubleWeapon {


function DoubleWeapon1(%val) { if (%val) DoubleWeapon(1); }
function DoubleWeapon2(%val) { if (%val) DoubleWeapon(2); }
function DoubleWeapon3(%val) { if (%val) DoubleWeapon(3); }
function DoubleWeapon4(%val) { if (%val) DoubleWeapon(4); }
function DoubleWeapon5(%val) { if (%val) DoubleWeapon(5); }

function DoubleWeapon(%slot)
{
	%first = $NameToInv[$InvWeapon[$pref::DoubleWeapon::Slot[%slot, 1]]];
	%second = $NameToInv[$InvWeapon[$pref::DoubleWeapon::Slot[%slot, 2]]];
	
	if (objectiveHud.gameType $= "TR2Game")
	{
		%first = "TR2" @ %first;
		%second = "TR2" @ %second;
	}

	if ($DroppedWeaponCurrent !$= %first && $DroppedWeaponHas[%first])
	{
		use(%first);
	}
	else
	if ($DroppedWeaponHas[%second])
	{
		use(%second);
	}
}

function DoubleWeaponHandleClientJoin(%msgType, %msgString, %name, %client, %target, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid)
{
	if (detag(%name) == $DoubleWeaponName)
	{
		$DoubleWeaponClient = detag(%client);
	}
}


function DoubleWeaponDefaults()
{
	$pref::DoubleWeapon::Slot[1, 1] = 5;
	$pref::DoubleWeapon::Slot[1, 2] = 7;
	$pref::DoubleWeapon::Slot[2, 1] = 1;
	$pref::DoubleWeapon::Slot[2, 2] = 0;
	$pref::DoubleWeapon::Slot[3, 1] = 2;
	$pref::DoubleWeapon::Slot[3, 2] = 6;
	$pref::DoubleWeapon::Slot[4, 1] = 3;
	$pref::DoubleWeapon::Slot[4, 2] = 9;
	$pref::DoubleWeapon::Slot[5, 1] = 4;
	$pref::DoubleWeapon::Slot[5, 2] = 8;
}

//
// --- Dlg Gui ---
//

function DoubleWeaponOptions(%val)
{
	if (%val) DoubleWeaponDlgToggle();
}

function DoubleWeaponDlgToggle()
{
	$DoubleWeaponToggle = !$DoubleWeaponToggle;
	if ($DoubleWeaponToggle)
	{
		Canvas.pushDialog(DoubleWeaponDlg);
		clientCmdTogglePlayHuds(false);
	}
	else
	{
		Canvas.popDialog(DoubleWeaponDlg);
		clientCmdTogglePlayHuds(true);
	}
}

function DoubleWeaponDlg::OnWake(%this)
{
	for (%i = 1; %i <= 5; %i++)
	{
		for (%j = 1; %j <=2; %j++)
		{
			for (%k = 0; %k < 10; %k++) { DoubleWeaponDlg.Slot[%i, %j].add($InvWeapon[%k], %k); }
			DoubleWeaponDlg.Slot[%i, %j].setSelected($pref::DoubleWeapon::Slot[%i, %j]);
		}
	}
	
	%this.wasCursorOn = Canvas.isCursorOn();
	if (!%this.wasCursorOn) CursorOn();
}

function DoubleWeaponDlg::OnSleep(%this)
{
	if (!%this.wasCursorOn) CursorOff();
	
	for (%i = 1; %i <= 5; %i++)
	{
		for (%j = 1; %j <=2; %j++)
		{
			$pref::DoubleWeapon::Slot[%i, %j] = DoubleWeaponDlg.Slot[%i, %j].getSelected();
			DoubleWeaponDlg.Slot[%i, %j].clear();
		}
	}
}

function DoubleWeaponSetDefaults()
{
	DoubleWeaponDefaults();
	
	for (%i = 1; %i <= 5; %i++)
	{
		for (%j = 1; %j <=2; %j++)
		{
			DoubleWeaponDlg.Slot[%i, %j].clear();
			for (%k = 0; %k < 10; %k++) { DoubleWeaponDlg.Slot[%i, %j].add($InvWeapon[%k], %k); }
			DoubleWeaponDlg.Slot[%i, %j].setSelected($pref::DoubleWeapon::Slot[%i, %j]);
		}
	}
}

function DoubleWeaponDlgSetup()
{
	addMessageCallback('MsgClientJoin', DoubleWeaponHandleClientJoin);
	exec("gui/DoubleWeaponDlg.gui");
	if ($pref::DoubleWeapon::Slot[1, 1] $= "") DoubleWeaponDefaults();
	
	// Easier to add all the pull down menus and text here
	for (%i = 1; %i <=5; %i++)
	{
		DoubleWeaponDlg.text[%i] = new GuiTextCtrl()
		{
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15" SPC (25+(%i-1)*30);
			extent = "100 22";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "Slot "@%i@":";
			maxLength = "255";
		};
		DoubleWeaponDlgCtrl.add(DoubleWeaponDlg.text[%i]);
		
		for (%j = 1; %j <=2; %j++)
		{
			DoubleWeaponDlg.Slot[%i, %j] = new ShellPopupMenu()
			{
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = (51+(%j-1)*170) SPC (17+(%i-1)*30);
				extent = "180 36";
				minExtent = "49 36";
				visible = "1";
				helpTag = "0";
				text = "Select Weapon";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};
			DoubleWeaponDlgCtrl.add(DoubleWeaponDlg.Slot[%i, %j]);
		}
	}
}

//
// --- Overrides ---
//

function clientCmdSetWeaponsHudActive(%slot)
{
	parent::clientCmdSetWeaponsHudActive(%slot);

	$DroppedWeaponCurrent = $WeaponNames[%slot];
}

function clientCmdSetWeaponsHudItem(%slot, %ammoAmount, %addItem)
{
	parent::clientCmdSetWeaponsHudItem(%slot, %ammoAmount, %addItem);

	$DroppedWeaponHas[$WeaponNames[%slot]] = %addItem;
}

function clientCmdSetWeaponsHudClearAll()
{
	parent::clientCmdSetWeaponsHudClearAll();
	
	$DroppedWeaponCurrent = "";
	deleteVariables("$DroppedWeaponHas*");
}

function DispatchLaunchMode()
{
	DoubleWeaponDlgSetup();

	parent::DispatchLaunchMode();
}

function OptionsDlg::onWake(%this)
{
	if (!$DoubleWeaponOptions)
	{
		$RemapName[$RemapCount] = "DoubleWeapon 1";
		$RemapCmd[$RemapCount]  = "DoubleWeapon1";
		$RemapCount++;	
		$RemapName[$RemapCount] = "DoubleWeapon 2";
		$RemapCmd[$RemapCount]  = "DoubleWeapon2";
		$RemapCount++;	
		$RemapName[$RemapCount] = "DoubleWeapon 3";
		$RemapCmd[$RemapCount]  = "DoubleWeapon3";
		$RemapCount++;	
		$RemapName[$RemapCount] = "DoubleWeapon 4";
		$RemapCmd[$RemapCount]  = "DoubleWeapon4";
		$RemapCount++;	
		$RemapName[$RemapCount] = "DoubleWeapon 5";
		$RemapCmd[$RemapCount]  = "DoubleWeapon5";
		$RemapCount++;	
		$RemapName[$RemapCount] = "DoubleWeapon Options";
		$RemapCmd[$RemapCount]  = "DoubleWeaponOptions";
		$RemapCount++;
		
		$DoubleWeaponOptions = true;
	}

	parent::onWake(%this);
}


}; // END package DoubleWeapon
activatePackage(DoubleWeapon);
